# std::signbit

From cppreference.com
< cpp‎ | numeric‎ | math

Defined in header `<cmath>` |  |
bool signbit( float arg ); | (1) | (since C++11)
bool signbit( double arg ); | (2) | (since C++11)
bool signbit( long double arg ); | (3) | (since C++11)
bool signbit( Integral arg ); | (4) | (since C++11)

1-3) Determines if the given floating point number `arg` is negative.
4) A set of overloads or a function template accepting the `from` argument of any integral type. Equivalent to (2) (the argument is cast to double).

### Parameters

arg | - | floating point value

### Return value

true if `arg` is negative, false otherwise

### Notes

This function detects the sign bit of zeroes, infinities, and NaNs. Along with std::copysign, std::signbit is one of the only two portable ways to examine the sign of a NaN.

### Examples

Run this code

    #include <iostream>
    #include <cmath>

    int main()
    {
        std::cout << std::boolalpha
                  << "signbit(+0.0) = " << std::signbit(+0.0) << '\n'
                  << "signbit(-0.0) = " << std::signbit(-0.0) << '\n';
    }

Output:

    signbit(+0.0) = false
    signbit(-0.0) = true

### See also

abs(float) fabs | absolute value of a floating point value (|x|) (function)
copysign (C++11) | copies the sign of a floating point value (function)
C documentation for signbit

Retrieved from "http://en.cppreference.com/mwiki/index.php?title=cpp/numeric/math/signbit&oldid=87517"